/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_LeftVentricleLinear;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_LeftVentricleLinear;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;

/**
 * This class represents LeftVentricleLinear CID12201
 */
public class LeftVentricleLinear_CID12201 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new LeftVentricleLinear_CID12201 Template 
	 */
	public LeftVentricleLinear_CID12201()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumLeftVentricleLinear Object of EnumCM_LeftVentricleLinear represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_LeftVentricleLinear enumLeftVentricleLinear)
	{
		switch(enumLeftVentricleLinear) 
		{
		case LEFT_VENTRICLE_INTERNAL_END_DIASTOLIC_DIMENSION: this.strCodeValue =EnumCV_LeftVentricleLinear.LEFT_VENTRICLE_INTERNAL_END_DIASTOLIC_DIMENSION_29436_3.getValue(); break;
		case LEFT_VENTRICLE_INTERNAL_SYSTOLIC_DIMENSION: this.strCodeValue =EnumCV_LeftVentricleLinear.LEFT_VENTRICLE_INTERNAL_SYSTOLIC_DIMENSION_29438_9.getValue(); break;
		case LEFT_VENTRICULAR_FRACTIONAL_SHORTENING: this.strCodeValue =EnumCV_LeftVentricleLinear.LEFT_VENTRICULAR_FRACTIONAL_SHORTENING_18051_3.getValue(); break;
		case INTERVENTRICULAR_SEPTUM_DIASTOLIC_THICKNESS: this.strCodeValue =EnumCV_LeftVentricleLinear.INTERVENTRICULAR_SEPTUM_DIASTOLIC_THICKNESS_18154_5.getValue(); break;
		case INTERVENTRICULAR_SEPTUM_TO_POSTERIOR_WALL_THICKNESS_RATIO: this.strCodeValue =EnumCV_LeftVentricleLinear.INTERVENTRICULAR_SEPTUM_TO_POSTERIOR_WALL_THICKNESS_RATIO_18155_2.getValue(); break;
		case INTERVENTRICULAR_SEPTUM_PERCENT_THICKENING: this.strCodeValue =EnumCV_LeftVentricleLinear.INTERVENTRICULAR_SEPTUM_PERCENT_THICKENING_18054_7.getValue(); break;
		case INTERVENTRICULAR_SEPTUM_SYSTOLIC_THICKNESS: this.strCodeValue =EnumCV_LeftVentricleLinear.INTERVENTRICULAR_SEPTUM_SYSTOLIC_THICKNESS_18158_6.getValue(); break;
		case LEFT_VENTRICLE_POSTERIOR_WALL_PERCENT_THICKENING: this.strCodeValue =EnumCV_LeftVentricleLinear.LEFT_VENTRICLE_POSTERIOR_WALL_PERCENT_THICKENING_18053_9.getValue(); break;
		case LEFT_VENTRICLE_DIASTOLIC_MAJOR_AXIS: this.strCodeValue =EnumCV_LeftVentricleLinear.LEFT_VENTRICLE_DIASTOLIC_MAJOR_AXIS_18077_8.getValue(); break;
		case LEFT_VENTRICLE_SYSTOLIC_MAJOR_AXIS: this.strCodeValue =EnumCV_LeftVentricleLinear.LEFT_VENTRICLE_SYSTOLIC_MAJOR_AXIS_18076_0.getValue(); break;
		case LEFT_VENTRICLE_POSTERIOR_WALL_SYSTOLIC_THICKNESS: this.strCodeValue =EnumCV_LeftVentricleLinear.LEFT_VENTRICLE_POSTERIOR_WALL_SYSTOLIC_THICKNESS_18156_0.getValue(); break;
		case LEFT_VENTRICLE_POSTERIOR_WALL_DIASTOLIC_THICKNESS: this.strCodeValue =EnumCV_LeftVentricleLinear.LEFT_VENTRICLE_POSTERIOR_WALL_DIASTOLIC_THICKNESS_18152_9.getValue(); break;
		case LEFT_VENTRICLE_SEMI_MAJOR_AXIS_DIASTOLIC_DIMENSION: this.strCodeValue =EnumCV_LeftVentricleLinear.LEFT_VENTRICLE_SEMI_MAJOR_AXIS_DIASTOLIC_DIMENSION_G_0377.getValue(); break;
		case LEFT_VENTRICLE_TRUNCATED_SEMI_MAJOR_AXIS_DIASTOLIC_DIMENSION: this.strCodeValue =EnumCV_LeftVentricleLinear.LEFT_VENTRICLE_TRUNCATED_SEMI_MAJOR_AXIS_DIASTOLIC_DIMENSION_G_0378.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumLeftVentricleLinear Object of EnumCM_LeftVentricleLinear represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_LeftVentricleLinear enumLeftVentricleLinear)
	{
		switch(enumLeftVentricleLinear)
		{
		case LEFT_VENTRICLE_SEMI_MAJOR_AXIS_DIASTOLIC_DIMENSION : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.LEFT_VENTRICLE_SEMI_MAJOR_AXIS_DIASTOLIC_DIMENSION.getSNOMEDCTID(); break;
		case LEFT_VENTRICLE_TRUNCATED_SEMI_MAJOR_AXIS_DIASTOLIC_DIMENSION : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.LEFT_VENTRICLE_TRUNCATED_SEMI_MAJOR_AXIS_DIASTOLIC_DIMENSION.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for LeftVentricleLinear
	 * @param enumLeftVentricleLinear Object of EnumCM_LeftVentricleLinear.
	 */
	public void setLeftVentricleLinear(EnumCM_LeftVentricleLinear enumLeftVentricleLinear)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumLeftVentricleLinear.getValue();
		if(this.strCodeMeaning.equalsIgnoreCase(EnumCM_LeftVentricleLinear.LEFT_VENTRICLE_SEMI_MAJOR_AXIS_DIASTOLIC_DIMENSION.getValue())||
			this.strCodeMeaning.equalsIgnoreCase(EnumCM_LeftVentricleLinear.LEFT_VENTRICLE_TRUNCATED_SEMI_MAJOR_AXIS_DIASTOLIC_DIMENSION.getValue()))
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		else
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.LN.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumLeftVentricleLinear);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumLeftVentricleLinear);
	}
}
